Index: utils/tools/DOMAINcfg/src/agrif_connect.F90
===================================================================
--- utils/tools/DOMAINcfg/src/agrif_connect.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/agrif_connect.F90	(revision 14623)
@@ -74,5 +74,5 @@
          ELSEWHERE
            ssmask(i1:i2,j1:j2) = 1.
-         END WHERE           
+         END WHERE  
       ENDIF
       !
@@ -146,5 +146,5 @@
                   IF( e3t_interp(ji,jj,jk) == -10 ) THEN ! the connection has not yet been done
                      e3t_interp(ji,jj,jk) = MAX( ptab(ji,jj,jk),MIN(e3zps_min, e3t_1d(jk)*e3zps_rat) )
-                     e3t_interp(ji,jj,jk) = MIN( e3t_interp(ji,jj,jk),e3t_1d(jk) )
+                  !   e3t_interp(ji,jj,jk) = MIN( e3t_interp(ji,jj,jk),e3t_1d(jk) )
                      e3t_0(ji,jj,jk) = ( 1. - ztabramp(ji,jj) )*e3t_0(ji,jj,jk) + ztabramp(ji,jj)*e3t_interp(ji,jj,jk)
                   ENDIF
@@ -180,44 +180,76 @@
       ! --- West --- !
       IF( ((nbondi == -1) .OR. (nbondi == 2) ).AND. .NOT. (jperio == 1 .OR. jperio == 4 .OR. jperio == 6)) THEN
-         ind1 = 1+nbghostcells + istart
+         ind1 = nn_hls + 1 + nbghostcells + istart
          ind2 = ind1 + ispongearea 
-         DO jj = 1, jpj
-            DO ji = ind1, ind2                
-               ztabramp(ji,jj) = REAL( ind2 - ji ) * z1_spongearea * umask(ind1,jj,1)
-            END DO
-         ENDDO
+         DO ji = mi0(ind1), mi1(ind2)   
+            DO jj = 1, jpj               
+               ztabramp(ji,jj) = REAL(ind2 - mig(ji), wp) * z1_spongearea * umask(ind1,jj,1)
+            END DO
+         ENDDO
+            ! ghost cells:
+            ind1 = 1
+            ind2 = nn_hls + 1 + nbghostcells + istart  ! halo + land + nbghostcells
+            DO ji = mi0(ind1), mi1(ind2)   
+               DO jj = 1, jpj               
+                  ztabramp(ji,jj) = 1._wp
+               END DO
+            END DO
       ENDIF
 
       ! --- East --- !
       IF( ((nbondi == 1) .OR. (nbondi == 2) ).AND. .NOT. (jperio == 1 .OR. jperio == 4 .OR. jperio == 6)) THEN
-         ind2 = nlci - nbghostcells - istart
+         ind2 = jpiglo -  (nn_hls + nbghostcells ) - istart
          ind1 = ind2 -ispongearea       
-         DO jj = 1, jpj
-            DO ji = ind1, ind2
-               ztabramp(ji,jj) = MAX( ztabramp(ji,jj), REAL( ji - ind1 ) * z1_spongearea * umask(ind2-1,jj,1) )
+         DO ji = mi0(ind1), mi1(ind2)
+            DO jj = 1, jpj
+               ztabramp(ji,jj) = MAX( ztabramp(ji,jj), REAL( mig(ji) - ind1 ) * z1_spongearea * umask(ind2-1,jj,1) )
             ENDDO
          ENDDO
+            ! ghost cells:
+            ind1 = jpiglo -  (nn_hls + nbghostcells ) - istart   ! halo + land + nbghostcells - 1
+            ind2 = jpiglo - 1
+            DO ji = mi0(ind1), mi1(ind2)
+               DO jj = 1, jpj
+                  ztabramp(ji,jj) = 1._wp
+               END DO
+            END DO
       ENDIF
 
       ! --- South --- !
       IF(( (nbondj == -1) .OR. (nbondj == 2) ).AND.(lk_south)) THEN
-         ind1 = 1+nbghostcells + istart
+         ind1 = nn_hls + 1 + nbghostcells + istart
          ind2 = ind1 + ispongearea 
-         DO jj = ind1, ind2 
+         DO jj = mj0(ind1), mj1(ind2) 
             DO ji = 1, jpi
-               ztabramp(ji,jj) = MAX( ztabramp(ji,jj), REAL( ind2 - jj ) * z1_spongearea * vmask(ji,ind1,1) )
-            END DO
-         ENDDO
+               ztabramp(ji,jj) = MAX( ztabramp(ji,jj), REAL( ind2 - mjg(jj) ) * z1_spongearea * vmask(ji,ind1,1) )
+            END DO
+         ENDDO
+            ! ghost cells:
+            ind1 = 1
+            ind2 = nn_hls + 1 + nbghostcells + istart                 ! halo + land + nbghostcells
+            DO jj = mj0(ind1), mj1(ind2) 
+               DO ji = 1, jpi
+                  ztabramp(ji,jj) = 1._wp
+               END DO
+            END DO
       ENDIF
 
       ! --- North --- !
       IF( (nbondj == 1) .OR. (nbondj == 2) ) THEN
-         ind2 = nlcj - nbghostcells - istart
-         ind1 = ind2 -ispongearea         
-         DO jj = ind1, ind2
+         ind2 = jpjglo - (nn_hls + nbghostcells) - istart
+         ind1 = ind2 -ispongearea
+         DO jj = mj0(ind1), mj1(ind2)
             DO ji = 1, jpi
-               ztabramp(ji,jj) = MAX( ztabramp(ji,jj), REAL( jj - ind1 ) * z1_spongearea * vmask(ji,ind2-1,1) )
-            END DO
-         ENDDO
+               ztabramp(ji,jj) = MAX( ztabramp(ji,jj), REAL( mjg(jj) - ind1 ) * z1_spongearea * vmask(ji,ind2-1,1) )
+            END DO
+         ENDDO
+            ! ghost cells:
+            ind1 = jpjglo - (nn_hls + nbghostcells) - istart      ! halo + land + nbghostcells - 1
+            ind2 = jpjglo
+            DO jj = mj0(ind1), mj1(ind2)
+               DO ji = 1, jpi
+                  ztabramp(ji,jj) = 1._wp
+               END DO
+            END DO
       ENDIF
       !
Index: utils/tools/DOMAINcfg/src/agrif_dom_update.F90
===================================================================
--- utils/tools/DOMAINcfg/src/agrif_dom_update.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/agrif_dom_update.F90	(revision 14623)
@@ -76,5 +76,5 @@
             DO jj=j1,j2
                DO ji=i1,i2
-                   IF( mbkt(ji,jj) .GE. jk ) THEN
+                   IF ((ssmask(ji,jj) /=0.).AND.( mbkt(ji,jj) .GE. jk )) THEN
                       tabres(ji,jj,jk) = e3t_0(ji,jj,jk)
                    ELSE
@@ -90,4 +90,5 @@
                    IF( mbkt(ji,jj) .GE. jk ) THEN
                       e3t_0(ji,jj,jk) = MAX(tabres(ji,jj,jk),MIN(e3zps_min,e3t_1d(jk)*e3zps_rat))
+                  !    e3t_0(ji,jj,jk) = tabres(ji,jj,jk)
                    ELSE
                       e3t_0(ji,jj,jk) = e3t_1d(jk)
@@ -97,5 +98,5 @@
          END DO
 
-         CALL lbc_lnk('update_e3t',e3t_0,'T',1.)
+         CALL lbc_lnk('update_e3t',e3t_0,'T',1.,kfillmode = jpfillcopy)
          !
       ENDIF
Index: utils/tools/DOMAINcfg/src/agrif_user.F90
===================================================================
--- utils/tools/DOMAINcfg/src/agrif_user.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/agrif_user.F90	(revision 14623)
@@ -45,5 +45,4 @@
       IMPLICIT NONE
       !
-      INTEGER :: nx, ny
       INTEGER :: irafx, irafy
       LOGICAL :: ln_perio
@@ -52,5 +51,4 @@
       irafy = agrif_irhoy()
 
-      nx = nlci ; ny = nlcj
 
    !       IF(jperio /=1 .AND. jperio/=4 .AND. jperio/=6 ) THEN
@@ -71,5 +69,5 @@
 
       WRITE(*,*) ' '
-      WRITE(*,*)'Size of the High resolution grid: ',nx,' x ',ny
+      WRITE(*,*)'Size of the High resolution grid: ',jpi,' x ',jpj
       WRITE(*,*) ' '
 
@@ -202,5 +200,4 @@
 
       INTEGER :: ind1, ind2, ind3
-      INTEGER :: nx, ny
       INTEGER ::nbghostcellsfine_tot_x, nbghostcellsfine_tot_y
       INTEGER :: irafx
@@ -211,8 +208,7 @@
       !---------------------------------------------------------------------
 
-      nx=nlci ; ny=nlcj
-
-      ind2 = 2 + nbghostcells_x
-      ind3 = 2 + nbghostcells_y_s
+      ind2 = nn_hls + 2 + nbghostcells_x
+      ind3 = nn_hls + 2 + nbghostcells_y_s
+
       nbghostcellsfine_tot_x=nbghostcells_x+1
       nbghostcellsfine_tot_y=max(nbghostcells_y_s,nbghostcells_y_n)+1
@@ -230,41 +226,41 @@
       endif
 
-      CALL agrif_declare_variable((/2,2/),(/ind2,ind3/),(/'x','y'/),(/1,1/),(/nx,ny/),glamt_id)
-      CALL agrif_declare_variable((/1,2/),(/ind2-1,ind3/),(/'x','y'/),(/1,1/),(/nx,ny/),glamu_id)
-      CALL agrif_declare_variable((/2,1/),(/ind2,ind3-1/),(/'x','y'/),(/1,1/),(/nx,ny/),glamv_id)
-      CALL agrif_declare_variable((/1,1/),(/ind2-1,ind3-1/),(/'x','y'/),(/1,1/),(/nx,ny/),glamf_id)
-
-      CALL agrif_declare_variable((/2,2/),(/ind2,ind3/),(/'x','y'/),(/1,1/),(/nx,ny/),gphit_id)
-      CALL agrif_declare_variable((/1,2/),(/ind2-1,ind3/),(/'x','y'/),(/1,1/),(/nx,ny/),gphiu_id)
-      CALL agrif_declare_variable((/2,1/),(/ind2,ind3-1/),(/'x','y'/),(/1,1/),(/nx,ny/),gphiv_id)
-      CALL agrif_declare_variable((/1,1/),(/ind2-1,ind3-1/),(/'x','y'/),(/1,1/),(/nx,ny/),gphif_id)
+      CALL agrif_declare_variable((/2,2/),(/ind2,ind3/),(/'x','y'/),(/1,1/),(/jpi,jpj/),glamt_id)
+      CALL agrif_declare_variable((/1,2/),(/ind2-1,ind3/),(/'x','y'/),(/1,1/),(/jpi,jpj/),glamu_id)
+      CALL agrif_declare_variable((/2,1/),(/ind2,ind3-1/),(/'x','y'/),(/1,1/),(/jpi,jpj/),glamv_id)
+      CALL agrif_declare_variable((/1,1/),(/ind2-1,ind3-1/),(/'x','y'/),(/1,1/),(/jpi,jpj/),glamf_id)
+
+      CALL agrif_declare_variable((/2,2/),(/ind2,ind3/),(/'x','y'/),(/1,1/),(/jpi,jpj/),gphit_id)
+      CALL agrif_declare_variable((/1,2/),(/ind2-1,ind3/),(/'x','y'/),(/1,1/),(/jpi,jpj/),gphiu_id)
+      CALL agrif_declare_variable((/2,1/),(/ind2,ind3-1/),(/'x','y'/),(/1,1/),(/jpi,jpj/),gphiv_id)
+      CALL agrif_declare_variable((/1,1/),(/ind2-1,ind3-1/),(/'x','y'/),(/1,1/),(/jpi,jpj/),gphif_id)
 
       ! Horizontal scale factors
 
-      CALL agrif_declare_variable((/2,2/),(/ind2,ind3/),(/'x','y'/),(/1,1/),(/nx,ny/),e1t_id)
-      CALL agrif_declare_variable((/1,2/),(/ind2-1,ind3/),(/'x','y'/),(/1,1/),(/nx,ny/),e1u_id)
-      CALL agrif_declare_variable((/2,1/),(/ind2,ind3-1/),(/'x','y'/),(/1,1/),(/nx,ny/),e1v_id)
-      CALL agrif_declare_variable((/1,1/),(/ind2-1,ind3-1/),(/'x','y'/),(/1,1/),(/nx,ny/),e1f_id)
-
-      CALL agrif_declare_variable((/2,2/),(/ind2,ind3/),(/'x','y'/),(/1,1/),(/nx,ny/),e2t_id)
-      CALL agrif_declare_variable((/1,2/),(/ind2-1,ind3/),(/'x','y'/),(/1,1/),(/nx,ny/),e2u_id)
-      CALL agrif_declare_variable((/2,1/),(/ind2,ind3-1/),(/'x','y'/),(/1,1/),(/nx,ny/),e2v_id)
-      CALL agrif_declare_variable((/1,1/),(/ind2-1,ind3-1/),(/'x','y'/),(/1,1/),(/nx,ny/),e2f_id)
+      CALL agrif_declare_variable((/2,2/),(/ind2,ind3/),(/'x','y'/),(/1,1/),(/jpi,jpj/),e1t_id)
+      CALL agrif_declare_variable((/1,2/),(/ind2-1,ind3/),(/'x','y'/),(/1,1/),(/jpi,jpj/),e1u_id)
+      CALL agrif_declare_variable((/2,1/),(/ind2,ind3-1/),(/'x','y'/),(/1,1/),(/jpi,jpj/),e1v_id)
+      CALL agrif_declare_variable((/1,1/),(/ind2-1,ind3-1/),(/'x','y'/),(/1,1/),(/jpi,jpj/),e1f_id)
+
+      CALL agrif_declare_variable((/2,2/),(/ind2,ind3/),(/'x','y'/),(/1,1/),(/jpi,jpj/),e2t_id)
+      CALL agrif_declare_variable((/1,2/),(/ind2-1,ind3/),(/'x','y'/),(/1,1/),(/jpi,jpj/),e2u_id)
+      CALL agrif_declare_variable((/2,1/),(/ind2,ind3-1/),(/'x','y'/),(/1,1/),(/jpi,jpj/),e2v_id)
+      CALL agrif_declare_variable((/1,1/),(/ind2-1,ind3-1/),(/'x','y'/),(/1,1/),(/jpi,jpj/),e2f_id)
 
       ! Bathymetry
 
-      CALL agrif_declare_variable((/2,2/),(/ind2,ind3/),(/'x','y'/),(/1,1/),(/nx,ny/),bathy_id)
+      CALL agrif_declare_variable((/2,2/),(/ind2,ind3/),(/'x','y'/),(/1,1/),(/jpi,jpj/),bathy_id)
 
       ! Vertical scale factors
-      CALL agrif_declare_variable((/2,2,0/),(/ind2,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/nx,ny,jpk/),e3t_id)
-      CALL agrif_declare_variable((/2,2,0/),(/ind2,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/nx,ny,jpk/),e3t_copy_id)
-      CALL agrif_declare_variable((/2,2,0/),(/ind2,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/nx,ny,jpk+1/),e3t_connect_id)
-
-      CALL agrif_declare_variable((/1,2,0/),(/ind2-1,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/nx,ny,jpk/),e3u_id)
-      CALL agrif_declare_variable((/2,1,0/),(/ind2,ind3-1,0/),(/'x','y','N'/),(/1,1,1/),(/nx,ny,jpk/),e3v_id)
+      CALL agrif_declare_variable((/2,2,0/),(/ind2,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/jpi,jpj,jpk/),e3t_id)
+      CALL agrif_declare_variable((/2,2,0/),(/ind2,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/jpi,jpj,jpk/),e3t_copy_id)
+      CALL agrif_declare_variable((/2,2,0/),(/ind2,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/jpi,jpj,jpk+1/),e3t_connect_id)
+
+      CALL agrif_declare_variable((/1,2,0/),(/ind2-1,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/jpi,jpj,jpk/),e3u_id)
+      CALL agrif_declare_variable((/2,1,0/),(/ind2,ind3-1,0/),(/'x','y','N'/),(/1,1,1/),(/jpi,jpj,jpk/),e3v_id)
 
       ! Bottom level
 
-      CALL agrif_declare_variable((/2,2/),(/ind2,ind3/),(/'x','y'/),(/1,1/),(/nx,ny/),bottom_level_id)
+      CALL agrif_declare_variable((/2,2/),(/ind2,ind3/),(/'x','y'/),(/1,1/),(/jpi,jpj/),bottom_level_id)
 
       CALL Agrif_Set_bcinterp(glamt_id,interp=AGRIF_linear)
@@ -348,6 +344,6 @@
       CALL Agrif_Set_bc( e3t_copy_id, (/-npt_copy*irafx,max(nbghostcellsfine_tot_x,nbghostcellsfine_tot_y)-1/))
 
-      CALL Agrif_Set_bcinterp(e3t_connect_id,interp=AGRIF_ppm)
-      CALL Agrif_Set_interp(e3t_connect_id,interp=AGRIF_ppm)
+      CALL Agrif_Set_bcinterp(e3t_connect_id,interp=AGRIF_linear)
+      CALL Agrif_Set_interp(e3t_connect_id,interp=AGRIF_linear)
       CALL Agrif_Set_bc( e3t_connect_id, (/-(npt_copy+npt_connect)*irafx-1,-npt_copy*irafx/))
 
@@ -589,13 +585,6 @@
       EXTERNAL :: init_glamt, init_glamu, init_glamv, init_glamf
       EXTERNAL :: init_gphit, init_gphiu, init_gphiv, init_gphif
-      REAL, EXTERNAL :: longitude_linear_interp
-
-      INTEGER :: ji,jj,i1,i2,j1,j2
-      REAL, DIMENSION(jpi,jpj) :: tab2dtemp
-      INTEGER :: ind2,ind3
-      INTEGER :: irhox, irhoy
-
-      irhox = agrif_irhox()
-      irhoy = agrif_irhoy()
+      EXTERNAL :: longitude_linear_interp
+
       CALL Agrif_Set_external_linear_interp(longitude_linear_interp)
 
@@ -637,10 +626,8 @@
       USE lbclnk
       LOGICAL :: ln_perio
-      INTEGER nx,ny
+      INTEGER jpi,jpj
 
       EXTERNAL :: init_e1t, init_e1u, init_e1v, init_e1f
       EXTERNAL :: init_e2t, init_e2u, init_e2v, init_e2f
-
-      nx = nlci ; ny = nlcj
 
       ln_perio=.FALSE.
@@ -1078,11 +1065,11 @@
       &  npt_copy
 
-      REWIND( numnam_ref )              ! Namelist namagrif in reference namelist : nesting parameters
+  !    REWIND( numnam_ref )              ! Namelist namagrif in reference namelist : nesting parameters
       READ  ( numnam_ref, namagrif, IOSTAT = ios, ERR = 901 )
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namagrif in reference namelist', lwp )
-
-      REWIND( numnam_cfg )              ! Namelist namzgr in configuration namelist : nesting parameters
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namagrif in reference namelist')
+
+  !    REWIND( numnam_cfg )              ! Namelist namzgr in configuration namelist : nesting parameters
       READ  ( numnam_cfg, namagrif, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namagrif in configuration namelist', lwp )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namagrif in configuration namelist')
       IF(lwm) WRITE ( numond, namagrif )
 
@@ -1102,13 +1089,16 @@
       nbghostcells_y_n = nbghostcells
 
+      IF ((jperio == 1).OR.(jperio == 4)) THEN
+        nbghostcells_x = 0
+      ENDIF
+      IF (jperio == 4) THEN
+        nbghostcells_y_s = 0
+      ENDIF
+
+      IF (.not.agrif_root()) THEN
       lk_west  = .NOT. ( Agrif_Ix() == 1 )
       lk_east  = .NOT. ( Agrif_Ix() + nbcellsx/AGRIF_Irhox() == Agrif_Parent(jpiglo) -1 )
       lk_south = .NOT. ( Agrif_Iy() == 1 )
       lk_north = .NOT. ( Agrif_Iy() + nbcellsy/AGRIF_Irhoy() == Agrif_Parent(jpjglo) -1 )
-
-      IF (.not.agrif_root()) THEN
-        IF (jperio == 1) THEN
-          nbghostcells_x = 0
-        ENDIF
         IF (.NOT.lk_south) THEN
           nbghostcells_y_s = 0
@@ -1146,6 +1136,6 @@
       !
       SELECT CASE( i )
-      CASE(1)   ;   indglob = indloc + nimppt(nprocloc+1) - 1
-      CASE(2)   ;   indglob = indloc + njmppt(nprocloc+1) - 1
+      CASE(1)   ;   indglob = mig(indloc)
+      CASE(2)   ;   indglob = mjg(indloc)
       CASE DEFAULT
          indglob = indloc
Index: utils/tools/DOMAINcfg/src/calendar.f90
===================================================================
--- utils/tools/DOMAINcfg/src/calendar.f90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/calendar.f90	(revision 14623)
@@ -1,3 +1,4 @@
 MODULE calendar
+!$AGRIF_DO_NOT_TREAT
 !-
 !$Id: calendar.f90 2459 2010-12-07 11:17:48Z smasson $
@@ -1042,3 +1043,4 @@
 !===
 !-
+!$AGRIF_END_DO_NOT_TREAT
 END MODULE calendar
Index: utils/tools/DOMAINcfg/src/do_loop_substitute.h90
===================================================================
--- utils/tools/DOMAINcfg/src/do_loop_substitute.h90	(revision 14623)
+++ utils/tools/DOMAINcfg/src/do_loop_substitute.h90	(revision 14623)
@@ -0,0 +1,68 @@
+#if defined show_comments
+! These comments are not intended to be retained during preprocessing; i.e. do not define "show_comments"
+!!----------------------------------------------------------------------
+!! NEMO/OCE 4.0 , NEMO Consortium (2018)
+!! Software governed by the CeCILL license (see ./LICENSE)
+!!----------------------------------------------------------------------
+! This header file contains preprocessor definitions and macros used in the do-loop substitutions introduced
+! between version 4.0 and 4.2. The primary aim of these macros is to assist in future applications of tiling
+! to improve performance. This is expected to be achieved by alternative versions of these macros in selected
+! locations. The initial introduction of these macros simply replaced all identifiable nested 2D- and 3D-loops
+! with single line statements (and adjusts indenting accordingly). Do loops were identifiable if they comformed
+! to either:
+!                                       DO jk = ....
+!   DO jj = ....                           DO jj = ...
+!      DO ji = ....                           DO ji = ...
+!         .                   OR                 .  
+!         .                                      .
+!     END DO                                  END DO
+!   END DO                                 END DO
+!                                       END DO
+! and white-space variants thereof.
+!
+! Additionally, only loops with recognised jj and ji loops limits were treated; these were:
+! Lower limits of 1, 2 or fs_2
+! Upper limits of jpi, jpim1 or fs_jpim1 (for ji) or jpj, jpjm1 or fs_jpjm1 (for jj)
+!
+! The macro naming convention takes the form: DO_2D( B, T, L, R) where: 
+!   B is the Bottom offset from the PE's inner domain;
+!   T is the Top    offset from the PE's inner domain;
+!   L is the Left   offset from the PE's inner domain;
+!   R is the Right  offset from the PE's inner domain
+!
+! So, given an inner domain of 2,jpim1 and 2,jpjm1, a typical example would replace:
+! 
+!   DO jj = 2, jpj
+!      DO ji = 1, jpim1
+!         .
+!         .
+!      END DO
+!   END DO
+!
+! with:
+!
+!   DO_2D( 0, 1, 1, 0 )
+!      .
+!      .
+!   END_2D
+! 
+! similar conventions apply to the 3D loops macros. jk loop limits are retained through macro arguments 
+! and are not restricted. This includes the possibility of strides for which an extra set of DO_3DS 
+! macros are defined.
+!
+! In the following definitions the inner PE domain is defined by start indices of (Nis0, Njs0) and end 
+! indices of (Nie0, Nje0) where:
+!
+! Nis0 =   1 + nn_hls     Njs0 =   1 + nn_hls
+! Nie0 = jpi - nn_hls     Nje0 = jpj - nn_hls
+! 
+#endif
+
+#define DO_2D(B, T, L, R) DO jj = Njs0-(B), Nje0+(T)   ;   DO ji = Nis0-(L), Nie0+(R)
+
+#define DO_3D(B, T, L, R, ks, ke) DO jk = ks, ke   ;   DO_2D(B, T, L, R)
+
+#define DO_3DS(B, T, L, R, ks, ke, ki) DO jk = ks, ke, ki   ;   DO_2D(B, T, L, R)
+
+#define END_2D   END DO   ;   END DO
+#define END_3D   END DO   ;   END DO   ;   END DO
Index: utils/tools/DOMAINcfg/src/dom_oce.F90
===================================================================
--- utils/tools/DOMAINcfg/src/dom_oce.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/dom_oce.F90	(revision 14623)
@@ -151,23 +151,36 @@
    INTEGER             , PUBLIC ::   nbondi, nbondj   !: mark of i- and j-direction local boundaries
 
+   !                             !: domain MPP decomposition parameters
+   INTEGER             , PUBLIC ::   nimpp, njmpp     !: i- & j-indexes for mpp-subdomain left bottom
+   INTEGER             , PUBLIC ::   nproc            !: number for local processor
+   INTEGER             , PUBLIC ::   narea            !: number for local area
+   INTEGER             , PUBLIC ::   nbondi, nbondj   !: mark of i- and j-direction local boundaries
+   INTEGER, ALLOCATABLE, PUBLIC ::   nbondi_bdy(:)    !: mark i-direction local boundaries for BDY open boundaries
+   INTEGER, ALLOCATABLE, PUBLIC ::   nbondj_bdy(:)    !: mark j-direction local boundaries for BDY open boundaries
+   INTEGER, ALLOCATABLE, PUBLIC ::   nbondi_bdy_b(:)  !: mark i-direction of neighbours local boundaries for BDY open boundaries  
+   INTEGER, ALLOCATABLE, PUBLIC ::   nbondj_bdy_b(:)  !: mark j-direction of neighbours local boundaries for BDY open boundaries  
+
    INTEGER, PUBLIC ::   npolj             !: north fold mark (0, 3 or 4)
-   INTEGER, PUBLIC ::   nlci, nldi, nlei  !: i-dimensions of the local subdomain and its first and last indoor indices
-   INTEGER, PUBLIC ::   nlcj, nldj, nlej  !: i-dimensions of the local subdomain and its first and last indoor indices
    INTEGER, PUBLIC ::   noea, nowe        !: index of the local neighboring processors in
    INTEGER, PUBLIC ::   noso, nono        !: east, west, south and north directions
    INTEGER, PUBLIC ::   nidom             !: ???
 
-   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   mig        !: local  ==> global domain i-index
-   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   mjg        !: local  ==> global domain j-index
-   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   mi0, mi1   !: global ==> local  domain i-index (mi0=1 and mi1=0 if the global index
-   !                                                                !                                             is not in the local domain)
-   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   mj0, mj1   !: global ==> local  domain j-index (mj0=1 and mj1=0 if the global index
-   !                                                                !                                             is not in the local domain)
-   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nimppt, njmppt   !: i-, j-indexes for each processor
-   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   ibonit, ibonjt   !: i-, j- processor neighbour existence
-   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nlcit , nlcjt    !: dimensions of every subdomain
-   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nldit , nldjt    !: first, last indoor index for each i-domain
-   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nleit , nlejt    !: first, last indoor index for each j-domain
-   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: nfiimpp, nfipproc, nfilcit
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   mig        !: local ==> global domain, including halos (jpiglo), i-index
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   mjg        !: local ==> global domain, including halos (jpjglo), j-index
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   mig0       !: local ==> global domain, excluding halos (Ni0glo), i-index
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   mjg0       !: local ==> global domain, excluding halos (Nj0glo), j-index
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   mig0_oldcmp !: local ==> global domain, excluding halos (Ni0glo), i-index
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   mjg0_oldcmp !: local ==> global domain, excluding halos (Nj0glo), j-index
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   mi0, mi1   !: global, including halos (jpiglo) ==> local domain i-index
+   !                                                                !:    (mi0=1 and mi1=0 if global index not in local domain)
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   mj0, mj1   !: global, including halos (jpjglo) ==> local domain j-index
+   !                                                                !:    (mj0=1 and mj1=0 if global index not in local domain)
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nimppt,  njmppt   !: i-, j-indexes for each processor
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   ibonit,  ibonjt   !: i-, j- processor neighbour existence
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   jpiall,  jpjall   !: dimensions of all subdomain
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nis0all, njs0all  !: first, last indoor index for all i-subdomain
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nie0all, nje0all  !: first, last indoor index for all j-subdomain
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nfimpp, nfproc, nfjpi
+
 
    !!----------------------------------------------------------------------
@@ -312,5 +325,6 @@
       ierr(:) = 0
       !
-      ALLOCATE( mig(jpi), mjg(jpj), STAT=ierr(1) )
+      ALLOCATE( mig(jpi), mjg(jpj), mig0(jpi), mjg0(jpj), mig0_oldcmp(jpi), mjg0_oldcmp(jpj),&
+                STAT=ierr(1) )
          !
       ALLOCATE( mi0(jpiglo)   , mi1 (jpiglo),  mj0(jpjglo)   , mj1 (jpjglo) ,     &
Index: utils/tools/DOMAINcfg/src/domain.F90
===================================================================
--- utils/tools/DOMAINcfg/src/domain.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/domain.F90	(revision 14623)
@@ -76,10 +76,12 @@
       !                       !==  Reference coordinate system  ==!
       !
+      CALL dom_glo                     ! global domain versus local domain
       CALL dom_nam               ! read namelist ( namrun, namdom )
+                  !   CALL dom_clo               ! Closed seas and lake
          
       CALL dom_hgr               ! Horizontal mesh
       CALL dom_zgr( ik_top, ik_bot )  ! Vertical mesh and bathymetry
       CALL dom_msk( ik_top, ik_bot )  ! Masks
-      IF ( ln_domclo ) CALL dom_clo               ! Closed seas and lake
+      !
       !
       CALL dom_ctl                  ! print extrema of masked scale factors
@@ -91,4 +93,58 @@
    END SUBROUTINE dom_init
 
+   SUBROUTINE dom_glo
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE dom_glo  ***
+      !!
+      !! ** Purpose :   initialization of global domain <--> local domain indices
+      !!
+      !! ** Method  :   
+      !!
+      !! ** Action  : - mig , mjg : local  domain indices ==> global domain, including halos, indices
+      !!              - mig0, mjg0: local  domain indices ==> global domain, excluding halos, indices
+      !!              - mi0 , mi1 : global domain indices ==> local  domain indices
+      !!              - mj0 , mj1   (if global point not in the local domain ==> mi0>mi1 and/or mj0>mj1)
+      !!----------------------------------------------------------------------
+      INTEGER ::   ji, jj   ! dummy loop argument
+      !!----------------------------------------------------------------------
+      !
+      DO ji = 1, jpi                 ! local domain indices ==> global domain, including halos, indices
+        mig(ji) = ji + nimpp - 1
+      END DO
+      DO jj = 1, jpj
+        mjg(jj) = jj + njmpp - 1
+      END DO
+      !                              ! local domain indices ==> global domain, excluding halos, indices
+      !
+      mig0(:) = mig(:) - nn_hls
+      mjg0(:) = mjg(:) - nn_hls  
+      ! WARNING: to keep compatibility with the trunk that was including periodocity into the input data, 
+      ! we must define mig0 and mjg0 as bellow.
+      ! Once we decide to forget trunk compatibility, we must simply define mig0 and mjg0 as:
+      mig0_oldcmp(:) = mig0(:) + COUNT( (/ jperio == 1 .OR. jperio == 4 .OR. jperio == 6 .OR. jperio == 7 /) )
+      mjg0_oldcmp(:) = mjg0(:) + COUNT( (/ jperio == 2 .OR. jperio == 7 /) )
+      !
+      !                              ! global domain, including halos, indices ==> local domain indices
+      !                                   ! (return (m.0,m.1)=(1,0) if data domain gridpoint is to the west/south of the 
+      !                                   ! local domain, or (m.0,m.1)=(jp.+1,jp.) to the east/north of local domain. 
+      DO ji = 1, jpiglo
+        mi0(ji) = MAX( 1 , MIN( ji - nimpp + 1, jpi+1 ) )
+        mi1(ji) = MAX( 0 , MIN( ji - nimpp + 1, jpi   ) )
+      END DO
+      DO jj = 1, jpjglo
+        mj0(jj) = MAX( 1 , MIN( jj - njmpp + 1, jpj+1 ) )
+        mj1(jj) = MAX( 0 , MIN( jj - njmpp + 1, jpj   ) )
+      END DO
+      IF(lwp) THEN                   ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) 'dom_glo : domain: global <<==>> local '
+         WRITE(numout,*) '~~~~~~~ '
+         WRITE(numout,*) '   global domain:   jpiglo = ', jpiglo, ' jpjglo = ', jpjglo, ' jpkglo = ', jpkglo
+         WRITE(numout,*) '   local  domain:   jpi    = ', jpi   , ' jpj    = ', jpj   , ' jpk    = ', jpk
+         WRITE(numout,*)
+      ENDIF
+      !
+   END SUBROUTINE dom_glo
+
    SUBROUTINE dom_nam
       !!----------------------------------------------------------------------
@@ -108,5 +164,5 @@
 
       NAMELIST/namdom/ ln_read_cfg, nn_bathy, cn_domcfg, cn_topo, cn_bath, cn_lon, cn_lat, rn_scale, nn_interp, &
-         &             cn_topolvl, cn_fisfd, cn_visfd, cn_bathlvl, cn_fcoord,                       & 
+         &             cn_topolvl, cn_fisfd, cn_visfd, cn_bathlvl, cn_fcoord,                        & 
          &             rn_bathy , rn_e3zps_min, rn_e3zps_rat, nn_msh, rn_hmin,                       &
          &             rn_atfp , rn_rdt   ,  ln_crs      , jphgr_msh ,                               &
@@ -116,13 +172,14 @@
 
       INTEGER  ::   ios                 ! Local integer output status for namelist read
-      !!----------------------------------------------------------------------
-
-      REWIND( numnam_ref )              ! Namelist namrun in reference namelist : Parameters of the run
+      CHARACTER(256) :: c_iomsg
+      !!----------------------------------------------------------------------
+
+   
       READ  ( numnam_ref, namrun, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namrun in reference namelist', lwp )
-
-      REWIND( numnam_cfg )              ! Namelist namrun in configuration namelist : Parameters of the run
-      READ  ( numnam_cfg, namrun, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namrun in configuration namelist', lwp )
+901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namrun in reference namelist')
+
+      READ  ( numnam_cfg, namrun, IOSTAT = ios, IOMSG = c_iomsg, ERR = 902 )
+
+902   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namrun in configuration namelist')
       IF(lwm) WRITE ( numond, namrun )
       !
@@ -152,12 +209,12 @@
       rn_scale = 1.
 
-      REWIND( numnam_ref )              ! Namelist namdom in reference namelist : space & time domain (bathymetry, mesh, timestep)
+      !REWIND( numnam_ref )              ! Namelist namdom in reference namelist : space & time domain (bathymetry, mesh, timestep)
       READ  ( numnam_ref, namdom, IOSTAT = ios, ERR = 903)
-903   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namdom in reference namelist', lwp )
+903   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namdom in reference namelist' )
   
       !
-      REWIND( numnam_cfg )              ! Namelist namdom in configuration namelist : space & time domain (bathymetry, mesh, timestep)
+      !REWIND( numnam_cfg )              ! Namelist namdom in configuration namelist : space & time domain (bathymetry, mesh, timestep)
       READ  ( numnam_cfg, namdom, IOSTAT = ios, ERR = 904 )
-904   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namdom in configuration namelist', lwp )
+904   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namdom in configuration namelist' )
       IF(lwm) WRITE ( numond, namdom )
       !
